# lbann-onnx Support Status
This file is automatically generated by `scripts/create_support_status.py`.
## LBANN to ONNX
| LBANN Layer | Converted ONNX Operator | Supported | Tested | Bijective |
|---|---|:-:|:-:|:-:|
| abs | [Abs](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Abs) | ✔ |  |  | 
| add | [Sum](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Sum) | ✔ |  | ✔ | 
| batch_normalization | [BatchNormalization](https://github.com/onnx/onnx/blob/master/docs/Operators.md#BatchNormalization) | ✔ | ✔ | ✔ | 
| binary_cross_entropy | [Multiple operators] | ✔ |  |  | 
| categorical_accuracy | [Multiple operators] | ✔ |  |  | 
| concatenation | [Concat](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Concat) | ✔ |  | ✔ | 
| constant | [Constant](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Constant) | ✔ |  |  | 
| convolution | [Conv](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Conv) | ✔ | ✔ | ✔ | 
| cross_entropy | [Multiple operators] | ✔ |  |  | 
| dropout | [Dropout](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Dropout) | ✔ |  | ✔ | 
| evaluation |  |  |  |  | 
| exp | [Exp](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Exp) | ✔ |  |  | 
| fully_connected | [Reshape](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Reshape), [Gemm](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Gemm) | ✔ |  |  | 
| gaussian | [RandomNormal](https://github.com/onnx/onnx/blob/master/docs/Operators.md#RandomNormal) | ✔ |  |  | 
| hadamard | [Mul](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Mul) | ✔ |  |  | 
| l2_norm2 |  |  |  |  | 
| leaky_relu | [LeakyRelu](https://github.com/onnx/onnx/blob/master/docs/Operators.md#LeakyRelu) | ✔ |  |  | 
| local_response_normalization | [LRN](https://github.com/onnx/onnx/blob/master/docs/Operators.md#LRN) | ✔ |  | ✔ | 
| mean_absolute_error | [Multiple operators] | ✔ |  |  | 
| mean_squared_error | [Multiple operators] | ✔ |  |  | 
| pooling | [MaxPool](https://github.com/onnx/onnx/blob/master/docs/Operators.md#MaxPool), [AveragePool](https://github.com/onnx/onnx/blob/master/docs/Operators.md#AveragePool) | ✔ | ✔ |  | 
| reduction | [ReduceSum](https://github.com/onnx/onnx/blob/master/docs/Operators.md#ReduceSum), [ReduceMean](https://github.com/onnx/onnx/blob/master/docs/Operators.md#ReduceMean) | ✔ |  |  | 
| relu | [Relu](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Relu) | ✔ | ✔ | ✔ | 
| reshape | [Reshape](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Reshape) | ✔ |  | ✔ | 
| rsqrt |  |  |  |  | 
| sigmoid | [Sigmoid](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Sigmoid) | ✔ |  |  | 
| sigmoid_binary_cross_entropy | [Multiple operators] | ✔ |  |  | 
| slice | [Split](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Split) | ✔ |  |  | 
| softmax | [Softmax](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Softmax) | ✔ |  | ✔ | 
| square |  |  |  |  | 
| sum | [Sum](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Sum) | ✔ |  | ✔ | 
| tanh | [Tanh](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Tanh) | ✔ |  |  | 
| top_k_categorical_accuracy |  |  |  |  | 
| unpooling | [MaxUnpool](https://github.com/onnx/onnx/blob/master/docs/Operators.md#MaxUnpool) | ✔ |  |  | 
| weighted_sum |  |  |  |  | 
| zero |  |  |  |  | 
## ONNX to LBANN
| ONNX Operator | Converted LBANN Layer | Supported | Tested | Bijective |
|---|---|:-:|:-:|:-:|
| [Add](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Add) | add | ✔ |  |  | 
| [AveragePool](https://github.com/onnx/onnx/blob/master/docs/Operators.md#AveragePool) | pooling | ✔ | ✔ |  | 
| [BatchNormalization](https://github.com/onnx/onnx/blob/master/docs/Operators.md#BatchNormalization) | batch_normalization | ✔ | ✔ | ✔ | 
| [Concat](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Concat) | concatenation | ✔ |  | ✔ | 
| [Conv](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Conv) | convolution | ✔ | ✔ | ✔ | 
| [Dropout](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Dropout) | dropout | ✔ |  | ✔ | 
| [Gemm](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Gemm) | fully_connected | ✔ | ✔ |  | 
| [LRN](https://github.com/onnx/onnx/blob/master/docs/Operators.md#LRN) | local_response_normalization | ✔ |  | ✔ | 
| [MatMul](https://github.com/onnx/onnx/blob/master/docs/Operators.md#MatMul) | fully_connected | ✔ |  |  | 
| [MaxPool](https://github.com/onnx/onnx/blob/master/docs/Operators.md#MaxPool) | pooling | ✔ | ✔ |  | 
| [Relu](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Relu) | relu | ✔ | ✔ | ✔ | 
| [Reshape](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Reshape) | reshape | ✔ |  | ✔ | 
| [Softmax](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Softmax) | softmax | ✔ |  | ✔ | 
| [Sum](https://github.com/onnx/onnx/blob/master/docs/Operators.md#Sum) | sum | ✔ |  | ✔ | 
